Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina
Interface Container

All Known Subinterfaces:
  Context, Engine, Host, Wrapper

All Known Implementing Classes:
  ContainerBase, StandardContext, StandardEngine, StandardHost, StandardWrapper

public interface Container

A Container is an object that can execute requests received from a client, and return responses based on those requests. A Container may optionally support a pipeline of Valves that process the request in an order configured at runtime, by implementing the Pipeline interface as well.

Containers will exist at several conceptual levels within Catalina. The following examples represent common cases:

- Engine - Representation of the entire Catalina servlet engine, most likely containing one or more subcontainers that are either Host or Context implementations, or other custom groups.
- Host - Representation of a virtual host containing a number of Contexts.
- Context - Representation of a single ServletContext, which will typically contain one or more Wrappers for the supported servlets.
- Wrapper - Representation of an individual servlet definition (which may support multiple servlet instances if the servlet itself implements SingleThreadModel).

A given deployment of Catalina need not include Containers at all of the levels described above. For example, an administration application embedded within a network device (such as a router) might only contain a single Context and a few Wrappers, or even a single Wrapper if the application is relatively small. Therefore, Container implementations need to be designed so that they will operate correctly in the absence of parent Containers in a given deployment.

A Container may also be associated with a number of support components that provide functionality which might be shared (by attaching it to a parent Container) or individually customized. The following support components are currently recognized:

- Loader - Class loader to use for integrating new Java classes for this Container into the JVM in which Catalina is running.
- Logger - Implementation of the `log()` method signatures of the `ServletContext` interface.
- Manager - Manager for the pool of Sessions associated with this Container.
- Realm - Read-only interface to a security domain, for authenticating user identities and their corresponding roles.
- Resources - JNDI directory context enabling access to static resources, enabling custom linkages to existing server components when Catalina is embedded in a larger server.

Version:
  $Revision: 1.8 $ $Date: 2004/05/26 15:25:05 $
Author:
  Craig R. McClanahan, Remy Maucherat

Field Summary
`static java.lang.String` | `ADD_CHILD_EVENT` The ContainerEvent event type sent when a child container is added by `addChild()`.
`static java.lang.String` | `ADD_MAPPER_EVENT` The ContainerEvent event type sent when a Mapper is added by `addMapper()`.
`static java.lang.String` | `ADD_VALVE_EVENT` The ContainerEvent event type sent when a valve is added by `addValve()`, if this Container supports pipelines.
`static java.lang.String` | `REMOVE_CHILD_EVENT` The ContainerEvent event type sent when a child container is removed by `removeChild()`.
`static java.lang.String` | `REMOVE_MAPPER_EVENT` The ContainerEvent event type sent when a Mapper is removed by `removeMapper()`.
`static java.lang.String` | `REMOVE_VALVE_EVENT` The ContainerEvent event type sent when a valve is removed by `removeValve()`, if this Container supports pipelines.

Method Summary
`void` | `addChild(Container child)` Add a new child Container to those associated with this Container, if supported.
`void` | `addContainerListener(ContainerListener listener)` Add a container event listener to this component.
`void` | `addPropertyChangeListener(java.beans.PropertyChangeListener listener)` Add a property change listener to this component.
`void` | `backgroundProcess()` Execute a periodic task, such as reloading, etc.
`Container` | `findChild(java.lang.String name)` Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`
`Container[]` | `findChildren()` Return the set of children Containers associated with this Container.
`ContainerListener[]` | `findContainerListeners()` Return the set of container listeners associated with this Container.
`int` | `getBackgroundProcessorDelay()` Get the delay between the invocation of the backgroundProcess method on this container and its children.
`Cluster` | `getCluster()` Return the Cluster with which this Container is associated.
`java.lang.String` | `getInfo()` Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.
`Loader` | `getLoader()` Return the Loader with which this Container is associated.
`Logger` | `getLogger()` Return the Logger with which this Container is associated.
`Manager` | `getManager()` Return the Manager with which this Container is associated.
`java.lang.Object` | `getMappingObject()` Return an object which may be utilized for mapping to this component.
`java.lang.String` | `getName()` Return a name string (suitable for use by humans) that describes this Container.
`Container` | `getParent()` Return the Container for which this Container is a child, if there is one.
`java.lang.ClassLoader` | `getParentClassLoader()` Return the parent class loader (if any) for web applications.
`Pipeline` | `getPipeline()` Return the Pipeline object that manages the Valves associated with this Container.
`Realm` | `getRealm()` Return the Realm with which this Container is associated.
`javax.naming.directory.DirContext` | `getResources()` Return the Resources with which this Container is associated.
`void` | `invoke(Request request, Response response)` Process the specified Request, and generate the corresponding Response, according to the design of this particular Container.
`void` | `removeChild(Container child)` Remove an existing child Container from association with this parent Container.
`void` | `removeContainerListener(ContainerListener listener)` Remove a container event listener from this component.
`void` | `removePropertyChangeListener(java.beans.PropertyChangeListener listener)` Remove a property change listener from this component.
`void` | `setBackgroundProcessorDelay(int delay)` Set the delay between the invocation of the execute method on this container and its children.
`void` | `setCluster(Cluster cluster)` Set the Cluster with which this Container is associated.
`void` | `setLoader(Loader loader)` Set the Loader with which this Container is associated.
`void` | `setLogger(Logger logger)` Set the Logger with which this Container is associated.
`void` | `setManager(Manager manager)` Set the Manager with which this Container is associated.
`void` | `setName(java.lang.String name)` Set a name string (suitable for use by humans) that describes this Container.
`void` | `setParent(Container container)` Set the parent Container to which this Container is being added as a child.
`void` | `setParentClassLoader(java.lang.ClassLoader parent)` Set the parent class loader (if any) for web applications.
`void` | `setRealm(Realm realm)` Set the Realm with which this Container is associated.
`void` | `setResources(javax.naming.directory.DirContext resources)` Set the Resources object with which this Container is associated.

Field Detail

### ADD_CHILD_EVENT

    public static final java.lang.String ADD_CHILD_EVENT

  The ContainerEvent event type sent when a child container is added by `addChild()`.

  See Also:
    Constant Field Values

### ADD_MAPPER_EVENT

    public static final java.lang.String ADD_MAPPER_EVENT

  The ContainerEvent event type sent when a Mapper is added by `addMapper()`.

  See Also:
    Constant Field Values

### ADD_VALVE_EVENT

    public static final java.lang.String ADD_VALVE_EVENT

  The ContainerEvent event type sent when a valve is added by `addValve()`, if this Container supports pipelines.

  See Also:
    Constant Field Values

### REMOVE_CHILD_EVENT

    public static final java.lang.String REMOVE_CHILD_EVENT

  The ContainerEvent event type sent when a child container is removed by `removeChild()`.

  See Also:
    Constant Field Values

### REMOVE_MAPPER_EVENT

    public static final java.lang.String REMOVE_MAPPER_EVENT

  The ContainerEvent event type sent when a Mapper is removed by `removeMapper()`.

  See Also:
    Constant Field Values

### REMOVE_VALVE_EVENT

    public static final java.lang.String REMOVE_VALVE_EVENT

  The ContainerEvent event type sent when a valve is removed by `removeValve()`, if this Container supports pipelines.

  See Also:
    Constant Field Values

Method Detail

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this Container implementation and the corresponding version number, in the format `<description>/<version>`.

### getLoader

    public Loader getLoader()

  Return the Loader with which this Container is associated. If there is no associated Loader, return the Loader associated with our parent Container (if any); otherwise, return `null`.

### setLoader

    public void setLoader(Loader loader)

  Set the Loader with which this Container is associated.

  Parameters:
    `loader` - The newly associated loader

### getLogger

    public Logger getLogger()

  Return the Logger with which this Container is associated. If there is no associated Logger, return the Logger associated with our parent Container (if any); otherwise return `null`.

### setLogger

    public void setLogger(Logger logger)

  Set the Logger with which this Container is associated.

  Parameters:
    `logger` - The newly associated Logger

### getManager

    public Manager getManager()

  Return the Manager with which this Container is associated. If there is no associated Manager, return the Manager associated with our parent Container (if any); otherwise return `null`.

### setManager

    public void setManager(Manager manager)

  Set the Manager with which this Container is associated.

  Parameters:
    `manager` - The newly associated Manager

### getMappingObject

    public java.lang.Object getMappingObject()

  Return an object which may be utilized for mapping to this component.

### getPipeline

    public Pipeline getPipeline()

  Return the Pipeline object that manages the Valves associated with this Container.

### getCluster

    public Cluster getCluster()

  Return the Cluster with which this Container is associated. If there is no associated Cluster, return the Cluster associated with our parent Container (if any); otherwise return `null`.

### setCluster

    public void setCluster(Cluster cluster)

  Set the Cluster with which this Container is associated.

  Parameters:
    `cluster` - the Cluster with which this Container is associated.

### getBackgroundProcessorDelay

    public int getBackgroundProcessorDelay()

  Get the delay between the invocation of the backgroundProcess method on this container and its children. Child containers will not be invoked if their delay value is not negative (which would mean they are using their own thread). Setting this to a positive value will cause a thread to be spawn. After waiting the specified amount of time, the thread will invoke the executePeriodic method on this container and all its children.

### setBackgroundProcessorDelay

    public void setBackgroundProcessorDelay(int delay)

  Set the delay between the invocation of the execute method on this container and its children.

  Parameters:
    `delay` - The delay in seconds between the invocation of backgroundProcess methods

### getName

    public java.lang.String getName()

  Return a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

### setName

    public void setName(java.lang.String name)

  Set a name string (suitable for use by humans) that describes this Container. Within the set of child containers belonging to a particular parent, Container names must be unique.

  Parameters:
    `name` - New name of this container
  Throws:
    `java.lang.IllegalStateException` - if this Container has already been added to the children of a parent Container (after which the name may not be changed)

### getParent

    public Container getParent()

  Return the Container for which this Container is a child, if there is one. If there is no defined parent, return `null`.

### setParent

    public void setParent(Container container)

  Set the parent Container to which this Container is being added as a child. This Container may refuse to become attached to the specified Container by throwing an exception.

  Parameters:
    `container` - Container to which this Container is being added as a child
  Throws:
    `java.lang.IllegalArgumentException` - if this Container refuses to become attached to the specified Container

### getParentClassLoader

    public java.lang.ClassLoader getParentClassLoader()

  Return the parent class loader (if any) for web applications.

### setParentClassLoader

    public void setParentClassLoader(java.lang.ClassLoader parent)

  Set the parent class loader (if any) for web applications. This call is meaningful only before a Loader has been configured, and the specified value (if non-null) should be passed as an argument to the class loader constructor.

  Parameters:
    `parent` - The new parent class loader

### getRealm

    public Realm getRealm()

  Return the Realm with which this Container is associated. If there is no associated Realm, return the Realm associated with our parent Container (if any); otherwise return `null`.

### setRealm

    public void setRealm(Realm realm)

  Set the Realm with which this Container is associated.

  Parameters:
    `realm` - The newly associated Realm

### getResources

    public javax.naming.directory.DirContext getResources()

  Return the Resources with which this Container is associated. If there is no associated Resources object, return the Resources associated with our parent Container (if any); otherwise return `null`.

### setResources

    public void setResources(javax.naming.directory.DirContext resources)

  Set the Resources object with which this Container is associated.

  Parameters:
    `resources` - The newly associated Resources

### backgroundProcess

    public void backgroundProcess()

  Execute a periodic task, such as reloading, etc. This method will be invoked inside the classloading context of this container. Unexpected throwables will be caught and logged.

### addChild

    public void addChild(Container child)

  Add a new child Container to those associated with this Container, if supported. Prior to adding this Container to the set of children, the child's `setParent()` method must be called, with this Container as an argument. This method may thrown an `IllegalArgumentException` if this Container chooses not to be attached to the specified Container, in which case it is not added

  Parameters:
    `child` - New child Container to be added
  Throws:
    `java.lang.IllegalArgumentException` - if this exception is thrown by the `setParent()` method of the child Container
    `java.lang.IllegalArgumentException` - if the new child does not have a name unique from that of existing children of this Container
    `java.lang.IllegalStateException` - if this Container does not support child Containers

### addContainerListener

    public void addContainerListener(ContainerListener listener)

  Add a container event listener to this component.

  Parameters:
    `listener` - The listener to add

### addPropertyChangeListener

    public void addPropertyChangeListener(java.beans.PropertyChangeListener listener)

  Add a property change listener to this component.

  Parameters:
    `listener` - The listener to add

### findChild

    public Container findChild(java.lang.String name)

  Return the child Container, associated with this Container, with the specified name (if any); otherwise, return `null`

  Parameters:
    `name` - Name of the child Container to be retrieved

### findChildren

    public Container[] findChildren()

  Return the set of children Containers associated with this Container. If this Container has no children, a zero-length array is returned.

### findContainerListeners

    public ContainerListener[] findContainerListeners()

  Return the set of container listeners associated with this Container. If this Container has no registered container listeners, a zero-length array is returned.

### invoke

    public void invoke(Request request,
                       Response response)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Process the specified Request, and generate the corresponding Response, according to the design of this particular Container.

  Parameters:
    `request` - Request to be processed
    `response` - Response to be produced
  Throws:
    `java.io.IOException` - if an input/output error occurred while processing
    `javax.servlet.ServletException` - if a ServletException was thrown while processing this request

### removeChild

    public void removeChild(Container child)

  Remove an existing child Container from association with this parent Container.

  Parameters:
    `child` - Existing child Container to be removed

### removeContainerListener

    public void removeContainerListener(ContainerListener listener)

  Remove a container event listener from this component.

  Parameters:
    `listener` - The listener to remove

### removePropertyChangeListener

    public void removePropertyChangeListener(java.beans.PropertyChangeListener listener)

  Remove a property change listener from this component.

  Parameters:
    `listener` - The listener to remove

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.